#!/etc/opt/openit/perl

# Applies the following updates to daft.conf:
# Adds this entry (license-model-user-concurrency $BEG $END P1H) in the licpoll2 field of the archiver section if it is not yet existing
# Adds this entry (license-model-total-usage $BEG $END P1H) in the licpoll2 field of the archiver section if it is not yet existing

BEGIN {
	if ( $^O ne 'MSWin32' ) {
		push(@INC, "/opt/openit/lib" );
        $ENV{'OPENIT_CFG'} = "/etc/opt/openit/openit.cfg"; 
	} 
	push(@INC, $ENV{'ALTUS'} . "/src/perl/source" ); 
}

## OpeniT Modules
use OpeniT::Config;
use strict;

my $CONFIG_DIR = &OpeniT::Config::CONFIG_DIR();
my $file = $CONFIG_DIR . "/daft.conf";
my @lines = read_file( $file );
my $index = 0;

print " Modifying $file\n";

# Updating licpoll2 field in archiver section here
$index = locate_line( $index, "archiver", \@lines );
$index = locate_line( $index, "filtrate", \@lines );
$index = locate_line( $index, "licpoll2", \@lines );

if( $index != 0 ) {
	if( @lines[$index] !~ /olap-raw-hourly/ ) {
		@lines[$index] =~ s/"\{\}/,olap-raw-hourly \$BEG \$END P1H\"\{\}/;
		print( " -- Datatype 93 added in DAFT\n" );
	}
	else
	{
		print( " -- Datatype 93 already exist in DAFT\n" );
	}
}

# Updating licpoll2 field in archiver section here
$index = locate_line( $index, "archiver", \@lines );
$index = locate_line( $index, "filtrate", \@lines );
$index = locate_line( $index, "licpoll2", \@lines );

if( $index != 0 ) {
	if( @lines[$index] !~ /olap-user-concurrency/ ) {
		@lines[$index] =~ s/"\{\}/,olap-user-concurrency \$BEG \$END P1H\"\{\}/;
		print( " -- Datatype 94 added in DAFT\n" );
	}
	else
	{
		print( " -- Datatype 94 already exist in DAFT\n" );
	}
}

# Updating licpoll2 field in archiver section here
$index = locate_line( $index, "archiver", \@lines );
$index = locate_line( $index, "filtrate", \@lines );
$index = locate_line( $index, "licpoll2", \@lines );

if( $index != 0 ) {
	if( @lines[$index] !~ /olap-group-concurrency/ ) {
		@lines[$index] =~ s/"\{\}/,olap-group-concurrency \$BEG \$END P1H\"\{\}/;
		print( " -- Datatype 95 added in DAFT\n" );
	}
	else
	{
		print( " -- Datatype 95 already exist in DAFT\n" );
	}
}

# Updating licpoll2 field in archiver section here
$index = locate_line( $index, "archiver", \@lines );
$index = locate_line( $index, "filtrate", \@lines );
$index = locate_line( $index, "licpoll2", \@lines );

if( $index != 0 ) {
	if( @lines[$index] !~ /olap-license-total-usage/ ) {
		@lines[$index] =~ s/"\{\}/,olap-license-total-usage \$BEG \$END P1H\"\{\}/;
		print( " -- Datatype 102 added in DAFT\n" );
	}
	else
	{
		print( " -- Datatype 102 already exist in DAFT\n" );
	}
}

# Updating licpoll2 field in archiver section here
$index = locate_line( $index, "archiver", \@lines );
$index = locate_line( $index, "filtrate", \@lines );
$index = locate_line( $index, "licpoll2", \@lines );

if( $index != 0 ) {
	if( @lines[$index] !~ /license-model-user-concurrency/ ) {
		@lines[$index] =~ s/"\{\}/,license-model-user-concurrency \$BEG \$END P1H\"\{\}/;
		print( " -- Datatype 124 added in DAFT\n" );
	}
	else
	{
		print( " -- Datatype 124 already exist in DAFT\n" );
	}
}

# Updating licpoll2 field in archiver section here
$index = locate_line( $index, "archiver", \@lines );
$index = locate_line( $index, "filtrate", \@lines );
$index = locate_line( $index, "licpoll2", \@lines );

if( $index != 0 ) {
	if( @lines[$index] !~ /license-model-total-usage/ ) {
		@lines[$index] =~ s/"\{\}/,license-model-total-usage \$BEG \$END P1H\"\{\}/;
		print( " -- Datatype 125 added in DAFT\n" );
	}
	else
	{
		print( " -- Datatype 125 already exist in DAFT\n" );
	}
}

save_file( $file, @lines );
exit( 0 );



sub read_file {
	my ( $cfg ) = @_;
	open( IN, $cfg ) || die "ERROR: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close( IN );
	return @lines;
}

sub locate_line {
	my ( $start, $find, $lines_ref ) = ( @_ );
	my ( $index ) = grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	return $index;
}

sub save_file {
	my ( $cfg, @lines ) = @_;
	open( OUT, ">$cfg" );
	print OUT @lines;
	close( OUT );
}
